#ifndef FUSE_FUNC_H
#define FUSE_FUNC_H

#include "common.h"
#include "db.h"

int   fs_getattr(const char *path, struct stat *info, struct fuse_file_info *fi);
int   fs_readlink(const char *path, char *buff, size_t len);
int   fs_readdir(const char *path, void *buff, fuse_fill_dir_t filler, off_t offset, struct fuse_file_info *fi, enum fuse_readdir_flags flags);
int   fs_mkdir(const char *path, mode_t mode);
int   fs_symlink(const char *src, const char *dst);
int   fs_unlink(const char *path);
int   fs_rmdir(const char *path);
int   fs_chmod(const char *path, mode_t mode, struct fuse_file_info *fi);
int   fs_chown(const char *path, uid_t uid, gid_t gid, struct fuse_file_info *fi);
int   fs_flush(const char *path, struct fuse_file_info *fi);
int   fs_release(const char *path, struct fuse_file_info *fi);
int   fs_rename(const char *src, const char *dst, unsigned int flags);
int   fs_truncate(const char *path, off_t size, struct fuse_file_info *fi);
int   fs_open(const char *path, struct fuse_file_info *fi);
int   fs_create(const char *path, mode_t mode, struct fuse_file_info *fi);
int   fs_read(const char *path, char *buff, size_t len, off_t offs, struct fuse_file_info *fi);
int   fs_write(const char *path, const char *buff, size_t len, off_t offs, struct fuse_file_info *fi);
int   fs_statfs(const char *path, struct statvfs *stbuff);
int   fs_utimens(const char *path, const struct timespec newTimes[2], struct fuse_file_info *fi);
int   fs_fallocate(const char *path, int mode, off_t offs, off_t len, struct fuse_file_info *fi);
void *fs_init(struct fuse_conn_info *conn, struct fuse_config *cfg);
void  fs_destroy(void *privateData);

#endif // FUSE_FUNC_H
